Imports System.Runtime.InteropServices

Module PsyQrDcd

    'Psytec QR Code Decode Library [Ver.1.57 2015/08/24]
    'PsyQrDcd.vb
    'DLLt@NV`
    '(C) 2003-2015 Psytec Inc.
    'URL:www.psytec.co.jp

    'G[R[h`
    Public Const QRD_ERROR_SYMBLE_NOT_FOUND As Short = 0
    Public Const QRD_ERROR_FILE_NOT_FOUND As Short = -1
    Public Const QRD_ERROR_READ_FAULT As Short = -2
    Public Const QRD_ERROR_BAD_FORMAT As Short = -3
    Public Const QRD_ERROR_SHARING_VIOLATION As Short = -4
    Public Const QRD_ERROR_NOT_ENOUGH_MEMORY As Short = -5

    't@NV
    '-----------------------------------------------------------------------
    'DecodePictureFile - 摜t@C̃fR[h
    '  F摜t@CpX(BMPAJPEGAGIFAPINGATIFF`)
    '߂lFfR[hꂽV{A܂͏LG[R[h

    Declare Function DecodePictureFile Lib "PsyQrDcd" ( _
      ByVal strFilePath As String _
    ) As Integer

    '-----------------------------------------------------------------------
    'DecodePictureFileRect - 摜t@C̃fR[hifR[h͈͎wj
    '  F摜t@CpX(BMPAJPEGAGIFAPINGATIFF`)AfR[h͈͍WiA゙AEAj
    '߂lFfR[hꂽV{A܂͏LG[R[h
    '  lFW͉摜Ŝ̍_ƂsNZPʂŎw肵ĂB

    Declare Function DecodePictureFileRect Lib "PsyQrDcd" ( _
      ByVal strFilePath As String, _
      ByVal intLeftX As Integer, _
      ByVal intTopY As Integer, _
      ByVal intRightX As Integer, _
      ByVal intBottomY As Integer _
    ) As Integer

    '-----------------------------------------------------------------------
    'DecodeGrayScaleArray - O[XP[(256K)f[^̃fR[h
    '  FO[XP[f[^z̉摜f[^(Byte^)A摜A摜
    '߂lFfR[hꂽV{A܂ QRD_ERROR_SYMBLE_NOT_FOUND, QRD_ERROR_NOT_ENOUGH_MEMORY
    '  lF摜f[^͍艡A1sNZɂ1oCgA256KA0= 255=
    '        z͐擪vfnĂBFbyData(0)

    Declare Function DecodeGrayScaleArray Lib "PsyQrDcd" ( _
      ByRef byData As Byte, _
      ByVal intWidth As Integer, _
      ByVal intHeight As Integer _
    ) As Integer

    '-----------------------------------------------------------------------
    'DecodeBinaryArray - oCi(2l)f[^̃fR[h
    '  FoCif[^z摜f[^(Byte^)A摜A摜
    '߂lFfR[hꂽV{A܂ QRD_ERROR_SYMBLE_NOT_FOUND, QRD_ERROR_NOT_ENOUGH_MEMORY
    '  lF摜f[^͍艡A1sNZɂ1oCgA2lA=False(0) =True(0ȊO)
    '        z͐擪vfnĂBFbyData(0)

    Declare Function DecodeBinaryArray Lib "PsyQrDcd" ( _
      ByRef byData As Byte, _
      ByVal intWidth As Integer, _
      ByVal intHeight As Integer _
    ) As Integer

    '-----------------------------------------------------------------------
    'GetDecodeData - fR[hʃf[^擾
    '  Ff[^CfbNX(0)Af[^󂯎obt@
    '߂lFf[^(oCg)A-1=f[^CfbNXs
    '  lFf[^󂯎obt@́AQRR[h̍őf[^(7089)mۂČĂяoĂB

    Declare Function GetDecodeData Lib "PsyQrDcd" ( _
      ByVal intIndex As Integer, _
      <MarshalAs(UnmanagedType.LPStr)> ByRef strBuff As StringBuilder _
    ) As Integer

    '-----------------------------------------------------------------------
    'GetDecodeDataByteArray - fR[hʃf[^擾(oCgz)
    '  Ff[^CfbNX(0)
    '߂lFfR[hf[^oCgzANull=CfbNXs
    '  lFoCif[^ƂăfR[hʂ擾ꍇɎgp

    Declare Function GetDecodeDataByteArray Lib "PsyQrDcd" ( _
      ByVal intIndex As Integer _
    ) As <MarshalAs(UnmanagedType.SafeArray)> Byte()

    '-----------------------------------------------------------------------
    'GetDecodeVersion - fR[hV{̌^Ԏ擾
    '  Ff[^CfbNX(0)
    '߂lF^(1`40)A-1=CfbNXs

    Declare Function GetDecodeVersion Lib "PsyQrDcd" ( _
      ByVal intIndex As Integer _
    ) As Integer

    '-----------------------------------------------------------------------
    'GetDecodeLevel - fR[hV{̌x擾
    '  Ff[^CfbNX(0)
    '߂lFx(0=L, 1=M, 2=Q, 3=H)A-1=CfbNXs

    Declare Function GetDecodeLevel Lib "PsyQrDcd" ( _
      ByVal intIndex As Integer _
    ) As Integer

    '-----------------------------------------------------------------------
    'GetDecodeMaskingNo - fR[hV{̃}XLOp^[ԍ擾
    '  Ff[^CfbNX(0)
    '߂lF}XLOp^[ԍ(0`7)A-1=CfbNXs

    Declare Function GetDecodeMaskingNo Lib "PsyQrDcd" ( _
      ByVal intIndex As Integer _
    ) As Integer

    '-----------------------------------------------------------------------
    'GetConcatenationInfo - fR[hV{̘A擾
    '  Ff[^CfbNX(0)AAV[PXAA`FbNfWbg
    '߂lFf[^A(1`16)A0=Af[^A-1=CfbNXs

    Declare Function GetConcatenationInfo Lib "PsyQrDcd" ( _
      ByVal intIndex As Integer, _
      ByRef intSeqNo As Integer, _
      ByRef byCheckDigit As Byte _
    ) As Integer

    '-----------------------------------------------------------------------
    'GetSymbolePosition - fR[hV{̈ʒu擾
    '  Ff[^CfbNX(0)AW󂯎z
    '߂lF0=IA-1=f[^CfbNXs
    '  lFW󂯎źAԂ̃V{̍ォ玞v
    '       (0)=゘A(1)=゙A(2)=E゘A(3)=E゙A(4)=EA(5)=EA(6)=A(7)=

    Declare Function GetSymbolePosition Lib "PsyQrDcd" ( _
      ByVal intIndex As Integer, _
      ByVal intPosition() As Integer _
    ) As Integer

    '-----------------------------------------------------------------------
    'SetDecodeSymbolCount - fR[hV{̏ݒ
    '  FfR[hV{(1`32)A0=ǂݎ萬_̃xŏI(l)
    '  lFfR[hł͗lXȉ摜ɑΉ邽ߕ̉摜HsĂ܂B
    '        0ݒ肵ꍇAꃌx̏œǂݎ邱ƂłV{͑Sēǂݎ܂B
    '        1ȏ̐ݒł͏ɒBƏI܂AtɏɒB܂ŏI܂̂ŁA
    '        ǂݗƂhꍇɂpB
    '        ݒl̓vOI(DLLA[h)܂ŗLłB

    Declare Sub SetDecodeSymbolCount Lib "PsyQrDcd" ( _
      ByVal intCount As Integer _
    )

    '-----------------------------------------------------------------------
    'SetDecodeEffectLevel - 摜x̐ݒ
    '  FfR[hx(0`3)Al=3
    '  lF0=łP2l̂ݍs܂B
    '        1=ݒ0ɉmCYs܂B
    '        2=ݒ0ɉ摜̕IȖÕ␳s܂B
    '        3=ݒ1Ɛݒ2̗̏s܂B
    '        ݒl̓vOI(DLLA[h)܂ŗLłB

    Declare Sub SetDecodeEffectLevel Lib "PsyQrDcd" ( _
      ByVal intLevel As Integer _
    )

    '-----------------------------------------------------------------------
    'SetBrightnessBorder - 摜Âlݒ
    '  FÂl(0`255)A0=ݒ
    '  lFݒ莞ɂ͉摜Ŝōł邢_ƈÂ_̒ԒllƂĂ܂
    '        V{ȊỎ摜܂܂ĂĤl߂ȂꍇȂǂɐݒ肵Ă
    '        ݒl̓vOI(DLLA[h)܂ŗLłB

    Declare Sub SetBrightnessBorder Lib "PsyQrDcd" ( _
      ByVal byBorder As Byte _
    )

    '-----------------------------------------------------------------------
    'SetMinimumModuleSize - V{ŏW[Pʐݒ
    '  FW[TCY(1`255)Al=1
    '  lFW[̑傫ȃV{FꍇK؂Ȓlݒ肷邱Ƃŏł܂
    '        ݒl̓vOI(DLLA[h)܂ŗLłB

    Declare Sub SetMinimumModuleSize Lib "PsyQrDcd" ( _
      ByVal bySize As Byte _
    )

    '-----------------------------------------------------------------------
    'FreeAllocateMemory - fR[hʕۑ̊J
    '  FW[TCY(1`255)Al=1
    '  lFfR[hʂ̃f[^V{ۑĂ郁J܂B
    '        ̉̓fR[hw֐̌ĂяoDLLA[hɂIɍs܂B

    Declare Sub FreeAllocateMemory Lib "PsyQrDcd" ()

    '-----------------------------------------------------------------------
    'GetErrorLevel - ǂݎG[ڍ׏擾
    '߂lF0=G[ȂA1=ʒuop^[oA2=ʒuop^[̃V{osA3=f[^ǂݎ莸s

    Declare Function GetErrorLevel Lib "PsyQrDcd" () As Long

End Module
